/* RTcmix  - Copyright (C) 2000  The RTcmix Development Team
   See ``AUTHORS'' for a list of contributors. See ``LICENSE'' for
   the license to this software and for a DISCLAIMER OF ALL WARRANTIES.
*/
#include <prototypes.h>
#include <iostream.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/time.h>
#include <sys/soundcard.h>  // for MIDI stuff  FIXME: not always right loc! -JGG
#include <maxdispargs.h>

#include "../rtstuff/rtdefs.h"


extern double getTime();

extern "C" {
void *parseit(void*)
{

	char *str;
	double p[MAXDISPARGS];
	int nargs;
	double startTime,curTime,difTime;
	struct timeval tv;
	struct timezone tz;

	int i,midi_fd,len,midiChan,oct,pitch;
	unsigned char datum;
	unsigned char noteVal;
	unsigned char noteVel;
	float opc;

	/* Set up parameters */
	str = strdup("rtsetparams");
	p[0] = 44100;
	p[1] = 1;
	nargs = 2;
	parse_dispatch(str, p, nargs, NULL);

	/* makegens */
	str = strdup("makegen");
	p[0] = 1;
	p[1] = 10;
	p[2] = 1000;
	p[3] = 1;
	nargs = 4;
	parse_dispatch(str, p, nargs, NULL);

	str = strdup("makegen");
	p[0] = 2;
	p[1] = 24;
	p[2] = 1000;
	p[3] = 0;
	p[4] = 0;
	p[5] = 3.5;
	p[6] = 1;
	p[7] = 7;
	p[8] = 0;
	nargs = 9;
	parse_dispatch(str, p, nargs, NULL);

	str = strdup("makegen");
	p[0] = 3;
	p[1] = 24;
	p[2] = 1000;
	p[3] = 0;
	p[4] = 1;
	p[5] = 7;
	p[6] = 0;
	nargs = 7;
	parse_dispatch(str, p, nargs, NULL);

	/* now set up a FMINST inst */
	str = strdup("FMINST");
	startTime = getTime();

	/* fprintf(stdout, "ENTERING PARSEIT FUNCTION\n"); */

	/* Open the MIDI port */
	if ((midi_fd = open("/dev/midi", O_RDONLY, 0)) == -1) { 
	  perror("/dev/midi");
	  exit(1);
	}

	while(1) {

	  /* Read in some MIDI data */
	  if ((len = read(midi_fd, &datum, 1)) == -1) {
	    perror("MIDI read");
	    exit(1);
	  }
	  
	  curTime = getTime();
	  difTime = (curTime-startTime);
	  
	  /* Only get "valid" note data */
	  if ((datum != 0xF8) && (datum != 0xFE)) {
	    
	    if ((datum >= 0x90) && (datum <= 0x9f)) {
	      midiChan = (datum-0x8f);
	      
	      if ((len = read(midi_fd, &datum, 1)) == -1) {
		perror("MIDI read");
		exit(1);
	      }
	    }
	    
	    noteVal = datum;
	    
	    if ((len = read(midi_fd, &datum, 1)) == -1) {
	      perror("MIDI read");
	      exit(1);
	    }
	    
	    if ((datum != 0xF8) && (datum != 0xFE)) {
	      
	      noteVel = datum;
	      
	      if ((noteVel > 0) && (noteVal > 0)) {
		pitch = noteVal%12;
		oct = noteVal/12;
		oct+=3;
		difTime+=(256/44100); 
		difTime += 1;
		opc = oct+(float)pitch/100;
		fprintf(stdout,"FMINST(%2.2f, 1, %2.2f, %2.2f, 0, 10, 5000)\n",difTime,opc,opc+1);

		/* Load values and play the instrument */
		p[0] = difTime;
		p[1] = 0.5;
		p[2] = opc;
		p[3] = opc+1;
		p[4] = 0;
		p[5] = 10;
		p[6] = 1000;
		parse_dispatch(str, p, nargs, NULL);
		
	      }
	    }
	  }
	}
	/* fprintf(stdout,"EXITING PARSEIT FUNCTION\n"); */
}
}









