/* vwavetable -- a vibrato wavetable sythesis instrument
*
*  p0 = start
*  p1 = duration
*  p2 = pitch (oct.pc or hz)
*  p3 = amplitude
*  p4 = vibrato rate low
*  p5 = vibrato rate high
*  p6 = vibrato depth (percentage)
*  p7 = stereo spread [optional]
*  assumes function table 1 is the synthesis waveform
*  assumes function table 2 is the amplitude envelope
*  assumes function table 3 is the vibrato waveform
*
*/

load("vwavetable")

output("ttt.snd")
makegen(1, 10, 1000, 1, 0, 0.3, 0, 0.1, 0, 0.05)
makegen(2, 24, 1000, 0,0, 0.5,1, 3.4,1, 3.5,0)
makegen(3, 10, 1000, 1)
fplot(3)
vwavetable(0, 3.5, 8.02, 10000, 4, 7, 1)
vwavetable(4.0, 3.5, 8.04, 10000, 4, 7, 10)
