/* transpan - modified version of Doug Scott's trans that does static
   panning from a mono input

   p0 = output start time
   p1 = input start time
   p2 = input duration (if negative, time to stop reading on input file)
   p3 = amplitude multiplier
   p4 = interval of transposition (8ve.pc)
   p5 = input channel number (from 0) [optional, default is 0]
   p6 = stereo position ("percent" to left, 0 - 1) [optional, default is .5]

   Assumes function table 1 is amplitude curve for the note. (Try gen 18.)
   Or you can just call setline. If no setline or function table 1, uses
   flat amplitude curve.

   The input file can be either stereo or mono. If mono, p6 (stereo pos.)
   is ignored.

   John Gibson <jgg9c@virginia.edu>, 2/8/00
*/
load("libtranspan.so")

system("rm -f /tmp/transpan1.wav")
system("sfcreate -t wav /tmp/transpan1.wav")
output("/tmp/transpan1.wav")

input("/snd/Public_Sounds/motorclip.snd")
indur = dur(0)
amp = .8

setline(0,0, 1,1, 9,1, 10,0)

transpan(start=0, inskip=0, indur, amp, transp=0.02, inchan=0, pctleft=1)
transpan(start=0, inskip=0, indur, amp, transp=-0.05, inchan=1, pctleft=0)

