#include <ugens.h>
#include <sfheader.h>
#include <stdio.h>

/* delay: regenerating delay instrument
*
*  p0 = output start time
*  p1 = input start time
*  p2 = input duration
*  p3 = amplitude multiplier
*  p4 = delay time
*  p5 = regeneration multiplier (< 1!)
*  p6 = ring-down duration
*  p7 = input channel number <optional>
*  p8 = stereo spread (0-1) <optional>
*  assumes function slot 1 is the amplitude envelope
*/

#define ARRSIZE 16384
extern SFHEADER      sfdesc[NFILES];

double delay(p,n_args)
float p[];
int n_args;
{
	long i,nsamps,n,m,count,smps = 0;
	long delsamps;
	float amp,val,wait,regen;
	int deltabs[2],j;
	float in[2*ARRSIZE],out[2*ARRSIZE];
	float *delarray;
	float *amparr,amptabs[2];
	int inchans,outchans,inchan,skip;
	float spread;
	extern int resetval;


	setnote(p[1],p[2],0);
	nsamps = setnote(p[0],p[2],1);

	inchans = sfchans(&sfdesc[0]);
	outchans = sfchans(&sfdesc[1]);

	delsamps = p[4]*SR + 0.5;
	if( (delarray = (float *)malloc(delsamps * sizeof(float))) == NULL ) {
		fprintf(stderr,"Sorry, Charlie -- no space\n");
		exit(-1);
		}
	wait = p[4];
	regen = p[5];
	delset(delarray,deltabs,wait);

	amparr = floc(1);
	if (amparr) {
		int lenamp = fsize(1);
		tableset(p[2], lenamp, amptabs);
	}
	else
		advise("delay", "Setting phrase curve to all 1's.");

	skip = SR/(float)resetval;
	j = 0;
	amp = p[3];
	inchan = 0;
	if (n_args > 7) inchan = p[7];
        if ((inchan+1) > inchans) {
		fprintf(stderr,"uh oh, you have asked for channel %d of a %d-channel file...\n",inchan,inchans);
		exit(-1);
		}
	spread = p[8];
	for (i = nsamps; i > 0; i -= ARRSIZE) {
		count = (i < ARRSIZE) ? i : ARRSIZE;
		count *= inchans;
		bgetin(in,0,count);
		m = 0;
                for (n = 0; n < count; n += inchans) {
                        while (!j--) {
                                if (amparr)
                                   val = tablei(smps,amparr,amptabs) * amp;
                                else
                                   val = amp;
                                j = skip;
                                smps += skip;
                                }
			out[m] = (in[n+inchan]*val) + (delget(delarray, wait, deltabs)*regen);
			delput(out[m], delarray, deltabs);
			if (outchans == 2) {
				out[m+1] = out[m] * (1.0 - spread);
				out[m] *= spread;
				}
			m += outchans;
			}
                baddout(out,1,count*outchans/inchans);
                }
	
	nsamps = p[6] * SR;
	for (i = 0; i < nsamps; i++) {
		out[0] = delget(delarray, wait, deltabs) * regen;
		delput(out[0], delarray, deltabs);
		if (outchans == 2) {
			out[1] = out[0] * (1.0 - spread);
			out[0] *= spread;
			}
		ADDOUT(out,1);
		}

	endnote(1);
}


profile()
{
	UG_INTRO("delay",delay);
}

