/* RTcmix  - Copyright (C) 2000  The RTcmix Development Team
   See ``AUTHORS'' for a list of contributors. See ``LICENSE'' for
   the license to this software and for a DISCLAIMER OF ALL WARRANTIES.
*/
#include <globals.h>
#include "../rtdefs.h"
#include "heap.h"
#include <iostream.h>

extern heap rtHeap;

void heapSched(Instrument *Iptr)
{
  int nsamps,startsamp,endsamp;
  int heapSize;
  int curslot;
  float start,dur;

  // Calculate variables for heap insertion
  dur = Iptr->getdur();
  nsamps = (int) (dur*SR);
  //  cout << "nsamps = " << nsamps << endl;
  
  start = Iptr->getstart();
  startsamp = (int) (start*SR);
  
  endsamp = startsamp+nsamps;
  Iptr->setendsamp(endsamp);  // used by traverse.C
  
  // place instrument into heap
  rtHeap.insert(Iptr, startsamp);
  
  // printf("heapify(): %d\n", heapSize);
}


